#!/usr/bin/perl
#
#  GruopCGI2000
#    abook.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './arraydb.pl';
require './cgi-lib.pl';
require './makemenu.pl';
require './make_admin_menu.pl';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

$icon_dir = '/andicon';
my $db_dir = './data';
$ADD_HTM = 'template/abook_add.htm';
$EDIT_HTM = 'template/abook_edit.htm';
$LIST_HTM = 'template/abook_list.htm';
$CONF_HTM = 'admin/abook_conf.htm';
$UP_ARROW = "$icon_dir/up.gif";
$DOWN_ARROW = "$icon_dir/down.gif";
$admin_uid = '9999';

($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $WDAY) = localtime(time);
$VAR{'MONTH'} = $THIS_MONTH + 1;
$VAR{'DAY'} = $TODAY;
$VAR{'YOBI'} = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$WDAY];

## browser parse --
ReadParse(*form);
$mode = $form{'mode'};
$search = $form{'search'};
$show = $form{'show'}; ## SHOW or HIDE
$direction = $form{'dir'}; ## UP or DOWN
$row = $form{'r'};
$col = $form{'c'};

@COL_LABEL = ("̾ ", "դ꤬", "̾", " ", " ", "ե", "  ",
	" 1", " 2", " ", " FAX ", " ", "E-Mail", "ۡڡ", " ", "¾");

## main --
if (! -e "$db_dir/abook.adb") {
	open (DATA, ">$db_dir/abook.adb") || &Error::error ("Can't open $db_dir/abook.adb", "$!");
	print DATA <<"EOM";
##
## User Information DB --
##
CONFIG {
	COL_LABEL_ORDER,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	COL_LABEL_SHOW,1,1,1,0,1,0,0,0,0,1,0,1,1,0,0,1
	COL_ORDER,0,1,2,4,9,11,12,15
	SHOW_ALL,1
}
I_CONFIG {
	COL_LABEL_ORDER,0,1,11,9,12
	COL_LABEL_SHOW,1,1,1,1,1
	COL_ORDER,0,1,11,9,12
}
LIST1 {
}
EOM
close DATA;
}

$data_db = ArrayDB->Retrieve ("abook");
$ra_LIST = $data_db->GetArray ('LIST1');
$users = @{$ra_LIST};
@row_order = (0 .. $users);

$ra_CONFIG = $data_db->GetArray ('CONFIG');

$sys_db = &HashDB::Retrieve ('sys');
$user_db = &HashDB::Retrieve ('user');
$rh_USER = $user_db->GetHash ('USER');
$group_db = &HashDB::Retrieve ('group');
$rh_GROUP = $group_db->GetHash ('GROUP');

$VAR{"MENU"} = &makemenu;

my @conf;
my $r = 0;
while (@conf = @{$ra_CONFIG->[$r]}) {
	my $conf_name = shift (@conf);
	if ($conf_name eq "COL_ORDER") { @col_order = @conf; }
	if ($conf_name eq "COL_LABEL_ORDER") { @col_label_order= @conf; }
	if ($conf_name eq "COL_LABEL_SHOW") { @col_label_show= @conf; }
	if ($conf_name eq "SHOW_ALL") { ($show_all) = @conf; }
	$r ++;
}

if ($mode eq "add") { &add; }
elsif ($mode eq "edit") { &edit; }
elsif ($mode eq "clear") { &clear; }
elsif ($mode eq "update") { &update; }
elsif ($mode eq "remove") { &remove; }
elsif ($mode eq "conf" && $uid eq $admin_uid) {
	$VAR{'ADMIN_MENU'} = &make_admin_menu();
	&conf;
}
else { &list; }

sub list {
	my ($ra_row_order, $ra_hit_col);
	if ($search ne "" && ref ($ra_LIST)) {
		($ra_LIST, $ra_row_order, $ra_hit_col) = $ra_LIST->Search ($search);
		@row_order = @{$ra_row_order};
	}
	if ($direction && ref ($ra_LIST)) {
		($ra_LIST, $ra_row_order) = $ra_LIST->Sort ($col, $type, $direction);
		@row_order = @row_order[@{$ra_row_order}];
	}
	my @row = @{$ra_LIST};

	my $r = 0;
	foreach (@row) {
		my @col = @{$_};
		if (!$col[16] && !$show_all) { $_ = ""; $r ++; next; }

		@col = @col[@col_order];
		my $c = 0;
		foreach (@col) {
			if ($_ eq "") { $_ = " - "; }
			if ($c == 0) { $_ = "<A HREF=\"abook.cgi?mode=edit&r=$row_order[$r]\">$_</A>"; }
			elsif (/\w+@\w+/) { $_ = "<A HREF=MAILTO:$_ style=text-decoration:none>$_</A>"; }
			elsif (/\w+\.\w+/) { $_ = "<A HREF=\"http://$_\">http://$_</A>"; }

			$_ = "<TD nowrap><FONT class=nFont>$_</FONT></TD>";

			$c ++;
        	}
		if ($search ne "") {
			my $hit_col = @{$_}[$ra_hit_col->[$r]];
			$hit_col =~ s/$search/<FONT color=\"red\">$search<\/FONT>/;
			unshift (@col, "<TD nowrap><FONT class=nFont>$hit_col</FONT></TD>");
		}

		if ($r % 2) { unshift (@col, "<TR class=\"line1\" align=\"center\">\n"); }
		else { unshift (@col, "<TR class=\"line1\" align=\"center\">\n"); }
		push (@col, "</TR>\n");

		$_ = join ("", @col);
		$r ++;

	}

	## table header --
	@header = @COL_LABEL[@col_order];
	my $c = 0;
	foreach (@header) {
		my $dir = 'UP';
		if ($col_order[$c] == $col && $direction eq 'UP') { $_ = "$_ "; $dir = 'DOWN'; }
		elsif ($col_order[$c] == $col && $direction eq 'DOWN') { $_ = "$_ "; $dir = 'UP'; }

		if ($search ne "") {
			my @col = ("<TD>",
				"<FORM action=\"abook.cgi\" method=\"GET\">",
				"<INPUT type=\"hidden\" name=\"search\" value=\"$search\">",
				"<INPUT type=\"hidden\" name=\"c\" value=\"$col_order[$c]\">",
				"<INPUT type=\"hidden\" name=\"dir\" value=\"$dir\">",
				"<INPUT type=\"submit\" value=\"$_\">",
				"</TD>",
				"</FORM>");
			$_ = join ("", @col);
		} else {
			my @col = ("<TD>",
				"<FORM action=\"abook.cgi\" method=\"GET\">",
				"<INPUT type=\"hidden\" name=\"c\" value=\"$col_order[$c]\">",
				"<INPUT type=\"hidden\" name=\"dir\" value=\"$dir\">",
				"<INPUT type=\"submit\" value=\"$_\">",
				"</TD>",
				"</FORM>");
			$_ = join ("", @col);
		}
		$c ++;
	}
	if ($search ne "") { unshift (@header, "<TD nowrap><FONT class=tFont size=\"-1\"></FONT></TD>"); }
	unshift (@header, "<TR align=\"center\" class=\"c8\">");
	push (@header, "</TR>\n");

	unshift (@row, @header);

	## table tags --
	unshift (@row, "<TABLE border=0 width=100% cellpadding=0 cellspacing=0 class=border><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"5\" cellspacing=1><TBODY>\n");
	push (@row, "</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'SEARCH_VALUE'} = "$search";
	$VAR{'NAME_LIST'} = "@row";

	print "Content-type: text/html\n\n";
	&parse_template("$LIST_HTM", *STDOUT);

	exit;
}
sub conf {
	my $flag = 0;
	if ($row ne "" && ($show || $direction)) {
		if ($show eq 'SHOW') { $col_label_show[$row] = '1'; }
		if ($show eq 'HIDE') { $col_label_show[$row] = '0'; }
		if ($direction eq 'UP') {
			@col_label_order[($row - 1, $row)] = @col_label_order[($row, $row - 1)];
			@col_label_show[($row - 1, $row)] = @col_label_show[($row, $row - 1)];
		}
		if ($direction eq 'DOWN') {
			@col_label_order[($row, $row + 1)] = @col_label_order[($row + 1, $row)];
			@col_label_show[($row, $row + 1)] = @col_label_show[($row + 1, $row)];
		}
		my @col_order_temp;
		my $c = 0;
		foreach (@col_label_order) {
			if ($col_label_show[$c]) { push (@col_order_temp, $_); }
			$c ++;
		}
		my @col_label_order_temp = @col_label_order;
		my @col_label_show_temp = @col_label_show;
		unshift (@col_label_order_temp, 'COL_LABEL_ORDER');
		unshift (@col_label_show_temp, 'COL_LABEL_SHOW');
		unshift (@col_order_temp, 'COL_ORDER');
		$ra_CONFIG->[0] = \@col_label_order_temp;
		$ra_CONFIG->[1] = \@col_label_show_temp;
		$ra_CONFIG->[2] = \@col_order_temp;

		$flag = 1;
	}
	if (defined ($form{'show_all'})) {
		$show_all = $form{'show_all'};
		$ra_CONFIG->[3] = ['SHOW_ALL', $show_all];
		$flag = 1;
	}
	if ($flag) {
		$data_db->SetArray ('CONFIG', $ra_CONFIG);
		$data_db->Store ();
	}

	my @row = @COL_LABEL[@col_label_order];
	my $last_row = $#row;

	my $r = 0;
	foreach (@row) {
		my $check_box;
		if ($col_label_show[$r]) {
			 $check_box = "<INPUT type=\"checkbox\" name=\"r\" value=\"$r\" onClick=\"location='abook.cgi?mode=conf&r=$r&show=HIDE'\" checked>";
		} else {
			$check_box = "<INPUT type=\"checkbox\" name=\"r\" value=\"$r\" onClick=\"location='abook.cgi?mode=conf&r=$r&show=SHOW'\">";
		}

		my $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=UP><IMG src=$UP_ARROW border=0 align=top></A> <A href=abook.cgi?mode=conf&r=$r&dir=DOWN><IMG src=$DOWN_ARROW border=0 align=top></A>";
		if ($r == 0) { $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=DOWN><IMG src=$DOWN_ARROW border=0 align=top></A>"; }
		elsif ($r == $last_row) { $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=UP><IMG src=$UP_ARROW border=0 align=top></A>"; }
		my @col = ($check_box,
			"<FONT class=nFont size=\"-1\">$_</FONT>",
			$arrows);
		foreach (@col) {
			$_ = "<TD nowrap>$_</TD>";
			$c ++;
        	}
		if ($r % 2) { unshift (@col, "<FORM><TR class=line2 align=\"center\">\n"); }
		else { unshift (@col, "<FORM><TR class=line1 align=\"center\">\n"); }
		push (@col, "</TR></FORM>\n");

		$_ = join ("", @col);
		$r ++;
	}

	## table header --
	unshift (@row, "<TR align=\"center\" class=c8>\n",
			"<TD width=\"20%\" nowrap><FONT class=tFont>ɽ</FONT></TD>",
			"<TD nowrap><FONT class=tFont>̾</FONT></TD>",
			"<TD width=\"20%\" nowrap><FONT class=tFont>ɽ</FONT></TD>",
			"</TR>");

	## table tags --
	unshift (@row, "<TABLE border=0 width=50% cellpadding=0 cellspacing=0 class=border><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=1><TBODY>\n");
	push (@row, "</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'CONF_TABLE'} = "@row";

	if ($show_all) {
		 $show_all = "<INPUT type=\"checkbox\" onClick=\"location='abook.cgi?mode=conf&show_all=0'\" checked>";
	} else {
		$show_all = "<INPUT type=\"checkbox\" onClick=\"location='abook.cgi?mode=conf&show_all=1'\">";
	}
	my @show_all = ("<TABLE border=0 width=50% cellpadding=0 cellspacing=0 class=border><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=1><TBODY>\n",
			"<TR align=\"center\">\n",
			"<TD class=c8 nowrap><FONT size=\"-1\" class=tFont>٤Ƥξɽ</FONT></TD>\n",
			"<TD class=line1 nowrap>$show_all</TD>\n",
			"</TR>\n",
			"</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'SHOW_ALL'} = "@show_all";

	print "Content-type: text/html\n\n";
	&parse_template("$CONF_HTM", *STDOUT);

	exit;
}
sub add {
	my $last_row = $#{$ra_LIST};
	my $flag = 0;
	foreach (@col_label_order) {
		my $col = $form{"c$_"};
		if ($col ne "") {
			$ra_LIST->[$last_row + 1]->[$_] = $col;
			$flag = 1;
		}
	}
	if ($flag) {
		$ra_LIST->[$last_row + 1]->[16] = 1;
		$data_db->SetArray ('LIST1', $ra_LIST);
		$data_db->Store ();
	}

	print "Content-type: text/html\n\n";
	&parse_template("$ADD_HTM", *STDOUT);

	exit;
}
sub edit {
	my @col = @{$ra_LIST->[$row]};
	my $c = 0;
	foreach (@col) {
		$VAR{"C$c"} = $col[$c];
		$c ++;
	}
	if ($col[16]) { $VAR{'C16_CHECKED'} = "checked"; }
	$VAR{"EDIT_ROW"} = $row;

	print "Content-type: text/html\n\n";
	&parse_template("$EDIT_HTM", *STDOUT);

	exit;
}
sub clear {
	$VAR{"EDIT_ROW"} = $row;
	print "Content-type: text/html\n\n";
	&parse_template("$EDIT_HTM", *STDOUT);

	exit;
}
sub update {
	foreach (@col_label_order) {
		my $col = $form{"c$_"};
		$col =~ s/\n|\r\n/<BR>/g;
		$col =~ s/,/<COMMA>/g;
		if (1) {
			$ra_LIST->[$row]->[$_] = $col;
		}
	}
	my $col = $form{"c16"};
	if ($col) { $ra_LIST->[$row]->[16] = 1; }
	else { $ra_LIST->[$row]->[16] = 0; }

	$data_db->SetArray ('LIST1', $ra_LIST);
	$data_db->Store ();

	&list;
}
sub remove {
	if ($row ne "") {
		splice (@{$ra_LIST}, $row, 1);
		$data_db->SetArray ('LIST1', $ra_LIST);
		$data_db->Store ();
	}
	&list;
}
sub select_type {
        return << "EOM";
<FORM>
<TD nowrap>
<SELECT onChange="location=this.options[this.selectedIndex].value">
<OPTION value="abook.cgi"></OPTION>
<OPTION value="abook.cgi?mode=add">Ͽ</OPTION>
<OPTION value="abook.cgi?mode=conf"></OPTION>
</SELECT>
</TD>
</FORM>
EOM
}
