#!/usr/bin/perl
#
#  GruopCGI2000
#    config.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './cgi-lib.pl';
require './template.pl';
require './make_admin_menu.pl';

$icon_dir = '/andicon';
$admin_dir = './admin';
$admin_uid = '9999';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }
if ($uid ne $admin_uid) {
	&Error::error ("YOU ARE NOT ADMINISTRATOR.",
		"Please login as admin.",
		"<A href=\"login.cgi\"><I>Go To Login</I></A>");
	exit;
}

ReadParse(*form);
$mode = $form{'mode'};
$conf = $form{'conf'};
$form1 = $form{'form1'};
$form2 = $form{'form2'};
$form3 = $form{'form3'};
$form4 = $form{'form4'};
$form5 = $form{'form5'};
$form6 = $form{'form6'};
$form7 = $form{'form7'};

$row = $form{'r'};
$col = $form{'c'};
$gid = $form{'gid'};
$VAR{'ADMIN_MENU'} = &make_admin_menu();

if (!$conf) { $conf = 1; } ## default config.

## some parameters ----
$DUMMY = "-";

($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $WDAY) = localtime(time);
$VAR{'MONTH'} = $THIS_MONTH + 1;
$VAR{'DAY'} = $TODAY;
$VAR{'YOBI'} = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$WDAY];

## main -----
$sys_db = &HashDB::Retrieve ('sys');
$group_db = &HashDB::Retrieve ('group');

if ($conf == 1) { &security_config; }
elsif ($conf == 2) { &sched_config; }
elsif ($conf == 3) {
	if ($mode eq "edit") { &kt_config_edit; }
	elsif ($mode eq "update") { &kt_config_update; }
	else { &kt_config; } }
elsif ($conf == 4) { &bk_config; }
elsif ($conf == 5) { &wb_config; }
else { &security_config; }

sub security_config {

	$rh_SEC = $sys_db->GetHash ('SYS_SEC_CONFIG');
	if ($mode eq "update") {
		if ($form1 =~ /\d+/ && $form1 > -1) {
			$rh_SEC->{'EXPIRE_MIN'} = $form1;
			$sys_db->SetHash ('SYS_SEC_CONFIG', $rh_SEC);
			$sys_db->Store ();
		}
	}

	$VAR{'EXPIRE_MIN'} = $rh_SEC->{'EXPIRE_MIN'};
	if ($rh_SEC->{'EXPIRE_MIN'} == 0){$VAR{'EXPIRE_MIN'} = '00';}

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf.htm", *STDOUT);
}
sub sched_config {

	$rh_SC = $sys_db->GetHash ('SYS_SC_CONFIG');
	if ($mode eq "update") {
		if ($form1 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_SC->{'AVAIL_S'} = $form1; }
		if ($form2 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_SC->{'AVAIL_E'} = $form2; }
		if ($form3 =~ /^[0-9]+\.?[0-9]*$/ && $form3 > 0) { $rh_SC->{'AVAIL_INT'} = $form3; }
		$sys_db->SetHash ('SYS_SC_CONFIG', $rh_SC);
		$sys_db->Store ();
	}

	$VAR{'SC_AVAIL_S'} = $rh_SC->{'AVAIL_S'};
	$VAR{'SC_AVAIL_E'} = $rh_SC->{'AVAIL_E'};
	$VAR{'SC_AVAIL_INT'} = $rh_SC->{'AVAIL_INT'};

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf.htm", *STDOUT);
}
sub kt_config {
	my $rh_KT = $sys_db->GetHash ('SYS_KT_CONFIG');
	my $rh_GROUP = $group_db->GetHash ('GROUP');

	## group configuration table ----
	my @row = keys (%{$rh_GROUP});
	@row = sort { $a <=> $b } @row;
	my $r = 1;
	foreach (@row) {
		my $gid = $_;
		my $gname = $rh_GROUP->{"$gid"}->{'NAME'};
		my ($shime, $kyukei, $syuro, $def_syukkin, $def_taikin, $date_line);
		if (exists ($rh_GROUP->{"$gid"}->{'KT_CONFIG'})) {
			my $rh_kt = $rh_GROUP->{"$gid"}->{'KT_CONFIG'};
			$shime = $rh_kt->{'SHIME'};
			$kyukei = $rh_kt->{'KYUKEI'};
			$syuro = $rh_kt->{'SYURO'};
			$def_syukkin = $rh_kt->{'DEF_SYUKKIN'};
			$def_taikin = $rh_kt->{'DEF_TAIKIN'};
			$date_line = $rh_kt->{'DATE_LINE'};
		} else {
			$shime = $rh_KT->{'SHIME'};
			$kyukei = $rh_KT->{'KYUKEI'};
			$syuro = $rh_KT->{'SYURO'};
			$def_syukkin = $rh_KT->{'DEF_SYUKKIN'};
			$def_taikin = $rh_KT->{'DEF_TAIKIN'};
			$date_line = $rh_KT->{'DATE_LINE'};
		}

		my $gid_show = $gid;
		if ($gid eq "None") { $gid_show = "$DUMMY"; }
		if ($shime eq "MATU") { $shime = ""; }
		my @col = (
#			$gid_show, 
			$gname,
			$shime, $kyukei, $syuro, "$def_syukkin - $def_taikin", $date_line);
		my $c = 1;
		foreach (@col) {
			if ($_ eq "") { $_ = "$DUMMY"; }
			$_ = "<FONT class=nFont>$_</FONT>";
			$_ = "<TD nowrap>$_</TD>"; 
			$c ++;
		} ## end of @col
		push (@col, "<TD nowrap><INPUT TYPE=\"button\" VALUE=\"Խ\" onClick=\"location = \'config.cgi?conf=$conf&mode=edit&gid=$gid\'\"></TD>");

		if ($r % 2) { unshift (@col, "<TR class=c13 align=\"center\">\n"); }
                else { unshift (@col, "<TR class=c1 align=\"center\">\n"); }
		push (@col, "</TR>\n");
		$_ = join ("", @col);

		$r ++;
	} ## end of @row

	## table header --
	unshift (@row, "<TR class=c1 align=\"center\">\n",
#                        "<TD nowrap><FONT class=nFont>롼ID</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>롼̾</FONT></TD>",
                         "<TD nowrap><FONT class=nFont></FONT></TD>",
                         "<TD nowrap><FONT class=nFont>ٷƻ</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>꽢ϫ</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>ե</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>ѹ</FONT></TD>",
                         "<TD nowrap>&nbsp;</TD>",
                         "</TR>\n");

	## table tags --
	unshift (@row, "<TABLE border=\"0\" width=\"90%\" class=border cellpadding=\"0\" cellspacing=\"0\"><FORM><TBODY>\n",
		"<TR><TD>\n",
		"<TABLE border=\"0\" width=\"100%\" cellpadding=\"2\" cellspacing=\"1\"><TBODY>\n");
        push (@row, "</TBODY></TABLE>\n",
		"</TD></TR>\n",
		"</TBODY></FORM></TABLE>\n");

	$VAR{'KT_CONFIG_TABLE'} = "@row";

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf.htm", *STDOUT);
}
sub kt_config_edit {
	my $rh_KT = $sys_db->GetHash ('SYS_KT_CONFIG');
	my $rh_GROUP = $group_db->GetHash ('GROUP');

	my $gname = $rh_GROUP->{"$gid"}->{'NAME'};
	my ($shime, $kyukei, $syuro, $def_syukkin, $def_taikin, $date_line);
	if (exists ($rh_GROUP->{"$gid"}->{'KT_CONFIG'})) {
		my $rh_kt = $rh_GROUP->{"$gid"}->{'KT_CONFIG'};
		$shime = $rh_kt->{'SHIME'};
		$kyukei = $rh_kt->{'KYUKEI'};
		$syuro = $rh_kt->{'SYURO'};
		$def_syukkin = $rh_kt->{'DEF_SYUKKIN'};
		$def_taikin = $rh_kt->{'DEF_TAIKIN'};
		$date_line = $rh_kt->{'DATE_LINE'};
	} else {
		$shime = $rh_KT->{'SHIME'};
		$kyukei = $rh_KT->{'KYUKEI'};
		$syuro = $rh_KT->{'SYURO'};
		$def_syukkin = $rh_KT->{'DEF_SYUKKIN'};
		$def_taikin = $rh_KT->{'DEF_TAIKIN'};
		$date_line = $rh_KT->{'DATE_LINE'};
	}
	$VAR{'GNAME'} = $gname;
	$VAR{'KYUKEI'} = $kyukei;
	$VAR{'SYURO'} = $syuro;
	$VAR{'DEF_SYUKKIN'} = $def_syukkin;
	$VAR{'DEF_TAIKIN'} = $def_taikin;
	$VAR{'DATE_LINE'} = $date_line;
	$VAR{'GID'} = $gid;

	## shime-bi options ----
	my @opt;
	my $d = 1;
	while ($d <=30) {
		if ($shime eq $d) { push (@opt, "<OPTION value=\"$d\" selected>$d</OPTION>"); }
		else { push (@opt, "<OPTION value=\"$d\">$d</OPTION>"); }
		$d ++;
	}
	if ($shime eq "MATU") { push (@opt, "<OPTION value=\"MATU\" selected></OPTION>"); }
	else { push (@opt, "<OPTION value=\"MATU\"></OPTION>"); }
	unshift (@opt, "<OPTION value=\"\">--</OPTION>");
	$VAR{'OPT1'} = "@opt";

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf\_$mode.htm", *STDOUT);
}
sub kt_config_update {
	my $rh_GROUP = $group_db->GetHash ('GROUP');

	my $rh_kt = $rh_GROUP->{"$gid"}->{'KT_CONFIG'};
	if ($form1 =~ /^[1-3]?[0-9]$/ || $form1 eq "MATU" || $form1 eq "") { $rh_kt->{'SHIME'} = $form1; }
	if ($form2 =~ /^[0-9]+\.?[0-9]*$/ || $form2 eq "") { $rh_kt->{'KYUKEI'} = $form2; }
	if ($form3 =~ /^[0-9]+\.?[0-9]*$/ || $form3 eq "") { $rh_kt->{'SYURO'} = $form3; }
	if ($form4 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/ || $form4 eq "") { $rh_kt->{'DEF_SYUKKIN'} = $form4; }
	if ($form5 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/ || $form5 eq "") { $rh_kt->{'DEF_TAIKIN'} = $form5; }
	if ($form6 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/ || $form6 eq "") { $rh_kt->{'DATE_LINE'} = $form6; }
	$rh_GROUP->{"$gid"}->{'KT_CONFIG'} = $rh_kt;
	$group_db->SetHash ('GROUP', $rh_GROUP);
	$group_db->Store ();

	&kt_config;
}
sub bk_config {

	$rh_BK = $sys_db->GetHash ('SYS_BK_CONFIG');
	if ($mode eq "update") {
		if ($form1 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_BK->{'AVAIL_S'} = $form1; }
		if ($form2 =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_BK->{'AVAIL_E'} = $form2; }
		if ($form3 =~ /^[0-9]+\.?[0-9]*$/ && $form3 > 0) { $rh_BK->{'AVAIL_INT'} = $form3; }

		$form4 =~ s/\n|\r\n/<BR>/g;
		if ($col == 0) {
			$rh_BK->{'GROUPS'}->{"$row"}->{'NAME'} = $form4;
			if(! $rh_BK->{'GROUPS'}->{"$row"}->{'NAME'}) {delete $rh_BK->{'GROUPS'}->{"$row"};}
		} elsif ($col > 0) {
			if ($form4 eq "") {
				my $rh_I = $rh_BK->{'GROUPS'}->{"$row"}->{'ITEMS'};
				my @items = keys (%{$rh_I});
				my $n = $col;
				while ($n < @items) {
					$rh_I->{"$n"} = $rh_I->{$n + 1};
					$n ++;
				}
				delete ($rh_I->{"$n"});
				$rh_BK->{'GROUPS'}->{"$row"}->{'ITEMS'} = $rh_I;
				if(! $rh_BK->{'GROUPS'}->{"$row"}->{'NAME'}) {delete $rh_BK->{'GROUPS'}->{"$row"};}
			} else {
				$rh_BK->{'GROUPS'}->{"$row"}->{'ITEMS'}->{"$col"}->{'NAME'} = $form4;
			}
		}
		$sys_db->SetHash ('SYS_BK_CONFIG', $rh_BK);
		$sys_db->Store ();
	}

	$VAR{'BK_AVAIL_S'} = $rh_BK->{'AVAIL_S'};
	$VAR{'BK_AVAIL_E'} = $rh_BK->{'AVAIL_E'};
	$VAR{'BK_AVAIL_INT'} = $rh_BK->{'AVAIL_INT'};

	my @groups = keys (%{$rh_BK->{'GROUPS'}});
	@groups = sort { $a <=> $b } @groups;
	my @row = @groups;
	push (@row, "");

	my @col_def;
	foreach (@groups) {
		my @items = keys (%{$rh_BK->{'GROUPS'}->{"$_"}->{'ITEMS'}});
		if (@col_def < @items) { @col_def = @items; }
	}
	push (@col_def, "", "");

	my $i;
	my $r = 1;
	foreach $g (@row) {
		my $c = 0;
		my @col = @col_def;
		foreach (@col) {
			if ($c == 0) { $_ = $rh_BK->{'GROUPS'}->{"$r"}->{'NAME'}; }
			else { $_ = $rh_BK->{'GROUPS'}->{"$r"}->{'ITEMS'}->{"$c"}->{'NAME'}; }

			if ($mode eq "edit" && $r == $row && $c == $col) {
				$editboxvalue = $_;
				$editboxvalue =~ s/<BR>/\n/g;
				$_ = &bk_edit_box;
			} else {
				if ($_ eq "") { $_ = "$DUMMY"; }
				$_ = "<FONT class=nFont>$_</FONT>";
				$_ = "<A HREF=config.cgi?conf=$conf&r=$r&c=$c&mode=edit>$_</A>";
			}
			$_ = "<TD nowrap>$_</TD>"; 

			$c ++;
		} ## end of @col

		my $group_num = $r;
		$group_num = "<TD nowrap><FONT class=nFont>$group_num</FONT></TD>";

		unshift (@col, $group_num);

		if ($r % 2) { unshift (@col, "<TR class=c13 align=\"center\">\n"); }
                else { unshift (@col, "<TR class=c1 align=\"center\">\n"); }
		push (@col, "</TR>\n");
		$g = join ("", @col);

		$r ++;
	} ## end of @row

	## table header --
	$c = 0;
	foreach (@col_def) {
		if ($c == 0) { $_ = "ơ֥̾"; }
		else { $_ = " $c"; }
		$_ = "<FONT class=nFont>$_</FONT></TD>";
		$_ = "<TD nowrap>$_</TD>";
		$c ++;
	}
	unshift (@col_def, "<TD nowrap><FONT class=nFont>No.</FONT></TD>");
	unshift (@row, "<TR class=c1 align=\"center\">\n",
			@col_def,
			"</TR>\n");

	## table tags --
	unshift (@row, "<TABLE border=\"0\" width=\"95%\" class=border cellpadding=\"0\" cellspacing=\"0\"><TBODY>\n",
		"<TR><TD>\n",
		"<TABLE border=\"0\" width=\"100%\" cellpadding=\"5\" cellspacing=\"1\"><TBODY>\n");
        push (@row, "</TBODY></TABLE>\n",
		"</TD></TR>\n",
		"</TBODY></TABLE>\n");

	$VAR{'BK_LABELS'} = "@row";

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf.htm", *STDOUT);
}
sub bk_edit_box {

	return <<"EOM";

            <TABLE border="0" class=border width=120 cellspacing="0">
                <FORM action="config.cgi" method="POST">
                <INPUT type="hidden" name="conf" value="$conf">
                <INPUT type="hidden" name="r" value="$row">
                <INPUT type="hidden" name="c" value="$col">
                <INPUT type="hidden" name="mode" value="update">
              <TBODY>
                <TR>
                  <TD>
                  <TABLE border=0 cellspacing=0 cellpadding=2 width=100%>
                    <TBODY>
                      <TR>
                        <TD class=c12 align="center" nowrap><FONT class=nFont>- Ͽ̾ -</FONT></TD>
                      </TR>
                      <TR>
                        <TD align="center" class=c12>
                        <TEXTAREA rows="2" cols="12" name="form4" class=aime>$editboxvalue</TEXTAREA>
                        </TD>
                      </TR>
                      <TR>
                        <TD align="center" class=c1>
                        <INPUT type="submit" value="  Ͽ ">
                        </TD>
                      </TR>
                    </TBODY>
                  </TABLE>
                  </TD>
                </TR>
              </TBODY>
                </FORM>
            </TABLE>
EOM
}
sub wb_config {

	$rh_WB = $sys_db->GetHash ('SYS_WB_CONFIG');
	if ($mode eq "update") {
		$form4 =~ s/\n|\r\n/<BR>/g;
		$rh_WB->{'GROUPS'}->{"$row"}->{'NAME'} = $form4;
		$sys_db->SetHash ('SYS_WB_CONFIG', $rh_WB);
		$sys_db->Store ();
	}

	my @groups = keys (%{$rh_WB->{'GROUPS'}});
	@groups = sort { $a <=> $b } @groups;

	my @row = @groups;
#	push (@row, "");
	my $r = 1;
	foreach (@row) {
		my $group_num = $r;
		$group_num = "<FONT class=nFont>$group_num</FONT>";
		$group_num = "<TD nowrap>$group_num</TD>"; 

		$_ = $rh_WB->{'GROUPS'}->{"$_"}->{'NAME'};
		if ($mode eq "edit" && $r == $row) {
			$editboxvalue = $_;
			$editboxvalue =~ s/<BR>/\n/g;
			$_ = &bk_edit_box;
		} else {
			if ($_ eq "") { $_ = "$DUMMY"; }
			$_ = "<FONT class=nFont>$_</FONT>";
			$_ = "<A HREF=config.cgi?conf=$conf&r=$r&mode=edit>$_</A>";
		}
		$_ = "<TD nowrap>$_</TD>"; 

		$_ = "$group_num$_";

		if ($r % 2) { $_ = "<TR class=c13 align=\"center\">\n$_</TR>\n"; }
		else { $_ = "<TR class=c1 align=\"center\">\n$_</TR>\n"; }

		$r ++;
	} ## end of @row

	## table header --
	unshift (@row, "<TR class=c1 align=\"center\">\n",
                         "<TD width=\"20%\" nowrap><FONT class=nFont>No.</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>ƥץ졼̾</FONT></TD>",
                         "</TR>\n");

	## table tags --
	unshift (@row, "<TABLE border=\"0\" width=\"400\" class=border cellpadding=\"0\" cellspacing=\"0\"><TBODY>\n",
		"<TR><TD>\n",
		"<TABLE border=\"0\" width=\"100%\" cellpadding=\"5\" cellspacing=\"1\"><TBODY>\n");
        push (@row, "</TBODY></TABLE>\n",
		"</TD></TR>\n",
		"</TBODY></TABLE>\n");

	$VAR{'WB_LABELS'} = "@row";

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$admin_dir/conf$conf.htm", *STDOUT);
}
