#!/usr/bin/perl
#
#  GruopCGI2000
#    job.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './datecalc.pl';
require './cgi-lib.pl';
require './makemenu.pl';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

$icon_dir = '/andicon';
$template_dir = './template';

@yobi = ("<FONT COLOR=\"#ff0000\"></FONT>", "", "", "", "", "", "");
@wdays = (Sun, Mon, Tue, Wed, Thu, Fri, Sat);

if(! -e "./data/$uid/job.hdb") {
	open(DATA, ">./data/$uid/job.hdb");
	print DATA "JOB {\n}\n";
	close DATA;
}
$job_db = &HashDB::Retrieve ("$uid/job");
$rh_JOB = $job_db->GetHash ('JOB');
$sys_db = &HashDB::Retrieve ('sys');
$user_db = &HashDB::Retrieve ('user');
$rh_USER = $user_db->GetHash ('USER');

ReadParse(*form);
$mode = $form{'mode'};
$name = $form{'name'};
$select_year = $form{'y'};
$select_month = $form{'m'};
$select_day = $form{'d'};
$id = $form{'id'};
$parent = $form{'parent'};

$VAR{'MONTH'} = "$THIS_MONTH";
$VAR{'DAY'} = "$TODAY";
$VAR{'YOBI'} = "$yobi[$THIS_WDAY]";
$VAR{'HOUR'} = "$HOUR";
$VAR{'MIN'} = "$MIN";
$VAR{'MENU'} = &makemenu;

if ($mode eq "link_add") {
	&link_add;
} elsif ($mode eq "link_del") {
	&link_del;
} elsif ($mode eq "link_del2") {
	&link_del2;
} elsif ($mode eq "set_stat") {
	&set_stat;
} elsif ($mode eq "update") {
	&update;
} elsif ($mode eq "update2") {
	&update2;
}else{
	&show_page;
}

sub show_page {
	my @data = keys (%{$rh_JOB});
	@data = sort { $b <=> $a } @data;
	my @job_list;
	foreach $parent_id (@data) {
		my $name = $rh_JOB->{"$parent_id"}->{'NAME'};
		my @table;
		my $end_stat = 0;
		my @child;
		
		###### Child
		if (defined %{$rh_JOB->{"$parent_id"}->{"CHILD"}}) {
			@child = keys (%{$rh_JOB->{"$parent_id"}->{"CHILD"}});
			@child = sort { $b <=> $a } @child;
			
			foreach $child_id (@child) {
				my $name = $rh_JOB->{"$parent_id"}->{"CHILD"}->{"$child_id"}->{'NAME'};
				my $value = $rh_JOB->{"$parent_id"}->{"CHILD"}->{"$child_id"}->{'VALUE'};
				my $stat = $rh_JOB->{"$parent_id"}->{"CHILD"}->{"$child_id"}->{'STAT'};

				$value =~ /^([^:]+):([^:]+):([^:]+)$/;
				my ($l_year, $l_month, $l_day) = ($1, $2, $3);
				my $class;
				if (! $stat) {
					$stat = "jc1_icon.gif";
					$class = 'c1';
					if ($1 < $THIS_YEAR) {
						$stat = "jc3_icon.gif";
						$class = 'c13';
					} elsif ($1 eq $THIS_YEAR && $2 < $THIS_MONTH) {
						$stat = "jc3_icon.gif";
						$class = 'c13';
					} elsif ($1 eq $THIS_YEAR && $2 eq $THIS_MONTH && $3 < $TODAY) {
						$stat = "jc3_icon.gif";
						$class = 'c13';
					}
				} else {
					$stat = "jc2_icon.gif";
					$end_stat ++;
					$class = 'c12';
				}

				if($mode eq 'link_edit' && $child_id eq $id) {
#					$VAR{'NAME'} = $name;
					push(@table, &edit_box($parent_id, $child_id, $name, $1, $2, $3));
				} else {
					push(@table, "<TR>\n",
						"<TD class=$class width=\"50%\" nowrap><A HREF=\"job.cgi?mode=link_edit&parent=$parent_id&id=$child_id\">\n",
						"<A HREF=\"job.cgi?mode=set_stat&parent=$parent_id&id=$child_id\">\n",
						"&nbsp;<IMG SRC=\"$icon_dir/$stat\" align=middle border=0>&nbsp;",
						"</A>\n",
						"<A HREF=\"job.cgi?mode=link_edit&parent=$parent_id&id=$child_id\">",
						"<FONT class=lFont>$name</FONT>",
						"</A>&nbsp;&nbsp;</TD>\n");
					if ($1 eq $THIS_YEAR) {
						push(@table, "<TD class=$class width=\"44%\" align=\"center\" nowrap><FONT class=nFont>  $2$3</FONT></TD>\n");
					} else {
						push(@table, "<TD class=$class width=\"44%\" align=\"center\" nowrap><FONT class=nFont>  $1ǯ$2$3</FONT></TD>\n");
					}
					push(@table,
#						"<TD class=$class nowrap></TD>\n",
						"<FORM action=\"job.cgi\" method=\"POST\" onSubmit=\"return deleteCheck()\">",
						"<INPUT type=\"hidden\" name=\"mode\" value=\"link_del\">",
						"<INPUT type=\"hidden\" name=\"parent\" value=\"$parent_id\">",
						"<INPUT type=\"hidden\" name=\"id\" value=\"$child_id\">",
						"<TD class=$class align=\"center\" width=1% nowrap><INPUT type=\"submit\" value=\"\">",
						"</TD>",
						"</FORM>\n",
						"</TR>\n");
				}
			}
		}
		
		###### Group
		if($mode eq 'link_edit2' && $parent_id eq $id) {
			## edit job group name
			unshift(@table, &edit_box2($id, $name));
		} else {
			## progress
			my $i;
			if ($end_stat ne "0") {
				$i = $end_stat / scalar(@child) * 100;
				$i = int($i);
			} else {
				$i = 0;
			}
#			my $width = $i * 3;
			unshift(@table, "<TR>",
				"<TD class=c1 nowrap colspan=\"3\"><img src=\"$icon_dir/dot.gif\" width=$i% height=11><FONT class=bFont> $i%</FONT></TD>\n",
				"</TR>\n");
			## job group title
			unshift(@table,	"<TABLE width=\"100%\" class=border border=\"0\" cellpadding=\"0\" cellspacing=\"0\">",
				"<TBODY><TR><TD><TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"1\">",
				"<FORM action=\"job.cgi\" method=\"POST\" onSubmit=\"return deleteCheck2()\"><INPUT type=\"hidden\" name=\"mode\" value=\"link_del2\"><INPUT type=\"hidden\" name=\"id\" value=\"$parent_id\">",
				"<TBODY>",
				"<TR>",
				"<TD class=c10 width=\"99%\" colspan=2 nowrap>",
				"<A HREF=\"job.cgi?mode=new_child&parent=$parent_id\">",
				"&nbsp;<IMG SRC=\"$icon_dir/jc_icon.gif\" border=0 alt=\"֥åȤȯ\">&nbsp;",
				"</A>",
				"<A HREF=\"job.cgi?mode=link_edit2&id=$parent_id\"><B><FONT class=bFont style=color:white>$name</FONT></B></A>",
				"</TD>",
				"<TD class=c10 align=\"center\" width=1% nowrap>",
				"<INPUT type=\"submit\" value=\"\">",
				"</TD>",
				"</FORM>",
				"</TR>"	);
		}
#		unshift(@table, "<TABLE width=\"100%\" class=border border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR><TD><TABLE width=\"100%\" #border=\"0\" cellpadding=\"0\" cellspacing=\"1\">",
#			"<TBODY>");

		if($mode eq 'new_child' && $parent_id eq $parent) {
			push(@table, &edit_box($parent_id, &create_unique_uid, "", $THIS_YEAR, $THIS_MONTH, $TODAY));
		}
#		push(@table, "</FORM>");
		push(@table, "</TBODY>","</TABLE>","</TD></TR></TBODY></TABLE>","<br>");
		push(@job_list, @table);
	}


	$VAR{"URL_LIST"} = join ("", @job_list);
	
	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Cache-Control: no-cache\n\n";
	&parse_template("$template_dir/job.htm", *STDOUT);
}
sub link_del {
	delete ($rh_JOB->{$parent}->{'CHILD'}->{$id});
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub link_del2 {
	delete ($rh_JOB->{$id});
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub link_add {
	$id = &create_unique_uid;
	$rh_JOB->{$id}->{'NAME'} = $name;
	$rh_JOB->{$id}->{'VALUE'} = $value;
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub set_stat {
#	$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'NAME'} = $name;
#	$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'VALUE'} = $value;
	if ($rh_JOB->{$parent}->{'CHILD'}->{$id}->{'STAT'} eq 'end') {
		$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'STAT'} = "";
	} else {
		$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'STAT'} = 'end';
	}
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub update {
	$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'NAME'} = $name;
	$rh_JOB->{$parent}->{'CHILD'}->{$id}->{'VALUE'} = "$select_year:$select_month:$select_day";
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub update2 {
	$rh_JOB->{$id}->{'NAME'} = $name;
	$job_db->SetHash ('JOB', $rh_JOB);
	$job_db->Store ();

	&show_page;
}
sub edit_box {
	my ($parent_id, $child_id, $name, $year, $month, $day) = @_;
	
	my $i, @y, @m, @d;
	for ($i=($THIS_YEAR-1);$i<=($THIS_YEAR+1);$i++) {
		if ($i eq $year) {
			push(@y, "<OPTION value\"$i\" selected>$i</OPTION>\n");
		}else{
			push(@y, "<OPTION value\"$i\">$i</OPTION>\n");
		}
	}
	for ($i=1;$i<=12;$i++) {
		if ($i eq $month) {
			push(@m, "<OPTION value\"$i\" selected>$i</OPTION>\n");
		}else{
			push(@m, "<OPTION value\"$i\">$i</OPTION>\n");
		}
	}
	for ($i=1;$i<=31;$i++) {
		if ($i eq $day) {
			push(@d, "<OPTION value\"$i\" selected>$i</OPTION>\n");
		}else{
			push(@d, "<OPTION value\"$i\">$i</OPTION>\n");
		}
	}
	
	return <<"EOM";
<TR align=center>
<TD class=c1 nowrap>
<FORM action="job.cgi" method="POST">
<INPUT type="hidden" name="mode" value="update">
<INPUT type="hidden" name="parent" value="$parent">
<INPUT type="hidden" name="id" value="$child_id">
<input type=text name="name" value="$name" size="50" class=aime>
</TD>
<TD class=c1 nowrap>
<FONT class=nFont>&nbsp;&nbsp;&nbsp;&nbsp;ò</FONT>
<SELECT name="y">@y</SELECT><FONT class=nFont>ǯ</FONT>
<SELECT name="m">@m</SELECT><FONT class=nFont></FONT>
<SELECT name="d">@d</SELECT><FONT class=nFont></FONT>
</TD>
<TD class=c12 align=center nowrap><INPUT type="submit" value="Ͽ"></TD>
</FORM>
</TR>
EOM
}
sub edit_box2 {
	my ($id, $name) = @_;
	return <<"EOM";
<TABLE width=100% class=border border=0 cellpadding=0 cellspacing=0>
<TBODY><TR><TD>
<TABLE width=100% border=0 cellpadding=0 cellspacing=1>
<TR align=center>
<TD CLASS=c10 colspan=2 NOWRAP>
<FORM action="job.cgi" method="POST">
<INPUT type="hidden" name="mode" value="update2">
<INPUT type="hidden" name="id" value="$id">
<INPUT type=text name="name" value="$name" size="50" class=aime>
</TD>
<TD class=t10 align=center nowrap><INPUT type="submit" value="Ͽ"></TD>
</FORM>
</TR>
EOM
}
sub create_unique_uid {
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	my $i = sprintf("%03d%02d%02d%02d%02d%02d", $year,$mon +1,$mday,$hour,$min,$sec);
	my @ids = keys (%{$rh_JOB});
	for (;;$i++) {
		my $flag = 1;
		foreach (@ids) {
			$flag = 0 if $_ eq $i;
		}
		return $i if $flag eq 1;
	}
}
