#!/usr/bin/perl
#
#  GruopCGI2000
#    makemenu.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
sub makemenu {
	return if ! $sys_db;

	if (!$rh_user) { 
		$rh_user = $rh_USER->{"$uid"};
	}
	my $default_gid = $rh_user->{'DEFAULT_GID'};

	my @hide_item;
	if ($default_gid) {
		@hide_item = split(/\W/, $rh_GROUP->{$default_gid}->{'HIDE_ITEM'});
	}else{
		$rh_HIDE = $sys_db->GetHash ('HIDE_ITEM');
		@hide_item = split(/\W/, $rh_HIDE->{'HIDE_ITEM'});
	}
	
	$rh_MENU = $sys_db->GetHash ('SYS_MENU_CONFIG');
	my @data = keys (%{$rh_MENU});
	@data = sort { $a <=> $b } @data;
	my @menu;
	foreach (@data) {
		my $flag = 0;
		foreach $item_id (@hide_item) {
			$flag = 1 if $_ eq $item_id;
		}
		if (-e $rh_MENU->{$_}->{'FILE'} || ($rh_MENU->{$_}->{'FILE'} =~ /http:\/\//)) {
			if ($flag ne 1) {
				push(@menu, "<TR>\n",
					"<TD width=1% class=menu>\n",
					"<IMG src=$icon_dir/$rh_MENU->{$_}->{'ICON'} border=0 valign=middle>\n",
					"</TD>\n",
					"<TD width=1% nowrap class=c12>\n",
					"<A href=\"$rh_MENU->{$_}->{'FILE'}\" target=\"_top\">\n",
					"<FONT class=lFont style=text-decoration:none>\n",
					"&nbsp;$rh_MENU->{$_}->{'NAME'}&nbsp;\n",
					"</FONT>\n",
					"</A>\n",
					"</TD>\n",
					"</TR>\n");
			}
		}
	}

	if ($my_name eq 'top.cgi') {
		push(@menu, "<TR>\n",
			"<TD width=1% class=menu>",
			"<FONT style=font-size:1pt>",
			"&nbsp;",
			"</FONT>",
			"</TD>",
			"<TD width=1% nowrap class=c12>",
			"<HR size=1 width=100%>",
			"</TD>",
			"</TR>");
		push(@menu, "<TR>\n",
			"<TD width=1% class=menu>\n",
			"<IMG src=\"$icon_dir/uconfig_icon.gif\" border=0 valign=middle>\n",
			"</TD>\n",
			"<TD width=1% nowrap class=c12>\n",
			"<A href=\"uconfig.cgi\" target=\"_top\">\n",
			"<FONT class=lFont style=text-decoration:none>\n",
			"&nbsp;桼&nbsp;\n",
			"</FONT>\n",
			"</A>\n",
			"</TD>\n",
			"</TR>\n");
	} else {
		push(@menu, "<TR>\n",
			"<TD width=1% class=menu>",
			"<FONT style=font-size:1pt>",
			"&nbsp;",
			"</FONT>",
			"</TD>",
			"<TD width=1% nowrap class=c12>",
			"<HR size=1 width=100%>",
			"</TD>",
			"</TR>");
		push(@menu, "<TR>\n",
			"<TD width=1% class=menu>\n",
			"<IMG src=\"$icon_dir/top_icon.gif\" border=0 valign=middle>\n",
			"</TD>\n",
			"<TD width=1% nowrap class=c12>\n",
			"<A href=\"top.cgi\" target=\"_top\">\n",
			"<FONT class=lFont style=text-decoration:none>\n",
			"&nbsp;ȥåץڡ&nbsp;\n",
			"</FONT>\n",
			"</A>\n",
			"</TD>\n",
			"</TR>\n");
	}
	push(@menu, "<TR>\n",
		"<TD width=1% class=menu>\n",
		"<IMG src=\"$icon_dir/logout_icon.gif\" border=0 valign=middle>\n",
		"</TD>\n",
		"<TD width=1% nowrap class=c12>\n",
		"<A href=\"login.cgi?mode=logout\" target=\"_top\">\n",
		"<FONT class=lFont style=text-decoration:none>\n",
		"&nbsp;&nbsp;\n",
		"</FONT>\n",
		"</A>\n",
		"</TD>\n",
		"</TR>\n");

	return join('', @menu);
}
1;
