#!/usr/bin/perl
#
#  GruopCGI2000
#    sched.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './sched.pl';
require './cgi-lib.pl';
require './makemenu.pl';

## authentication --
$myuid = &Auth;
if (!$myuid) { exit; }

$icon_dir = '/andicon';
$sched_dir = './template';
@yobi = ("", "", "", "", "", "", "<FONT COLOR=\"#ff0000\"></FONT>");
@monthdays = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
if ((($year % 4 == 0) && ($year % 100 != 0)) || ($year % 400 == 0)) { $monthdays[1] = 29; }
@monthnames = ("January", "February", "March", "April", "May",
		"June", "July", "August", "September", "October", "November", "December");
$DUMMY = "";

## browser parse --
ReadParse(*form);
$uid = $form{'uid'};
$mode = $form{'mode'};
$sc = $form{'sc'};
$year = $form{'y'};
$month = $form{'m'};
$yweek = $form{'yw'};
$wday = $form{'wd'};
$ins = $form{'i'};

$int1 = $form{'t1'};
$int2 = $form{'t2'};
$type1 = $form{'type1'};
$type2 = $form{'type2'};
$value = $form{'value'};

if (!$sc) { $sc = 2; }  ## default sched!
if (!$year) { $year = $THIS_YEAR; }
if (!$month) { $month = $THIS_MONTH; }
if (!$yweek) { $yweek = &GetYweek ($THIS_YEAR, $THIS_MONTH, $TODAY); }
if ($THIS_WDAY == 0) { $this_wday = 6; } else { $this_wday = $THIS_WDAY - 1; }
if (!$uid) { $uid = $myuid; }

## main --
$user_db = &HashDB::Retrieve ('user');
$sys_db = &HashDB::Retrieve ('sys');
$rh_USER = $user_db->GetHash ('USER');
$group_db = &HashDB::Retrieve ('group');
$rh_GROUP = $group_db->GetHash ('GROUP');
$rh_user = $rh_USER->{"$uid"};
$rh_SC = $sys_db->GetHash ('SYS_SC_CONFIG');
if ($default_gid eq "") { $default_gid = $rh_user->{'DEFAULT_GID'}; }

$SC_AVAIL_S = $rh_USER->{"$myuid"}->{'SC_CONFIG'}->{'AVAIL_S'};
$SC_AVAIL_E = $rh_USER->{"$myuid"}->{'SC_CONFIG'}->{'AVAIL_E'};
$SC_AVAIL_INT = $rh_USER->{"$myuid"}->{'SC_CONFIG'}->{'AVAIL_INT'};
if (!$SC_AVAIL_S) { $SC_AVAIL_S = $rh_SC->{'AVAIL_S'}; }
if (!$SC_AVAIL_E) { $SC_AVAIL_E = $rh_SC->{'AVAIL_E'}; }
if (!$SC_AVAIL_INT) { $SC_AVAIL_INT = $rh_SC->{'AVAIL_INT'}; }

$RW = $rh_USER->{"$uid"}->{'SC_GRANT'}->{"$myuid"};
if ($uid == $myuid) { $RW = "RW"; }
if (!($RW eq "RW" || $RW eq "R")) { $uid = $myuid; }

$VAR{'MONTH'} = "$THIS_MONTH";
$VAR{'DAY'} = "$TODAY";
$VAR{'YOBI'} = "$yobi[$this_wday]";
$VAR{'HOUR'} = "$HOUR";
$VAR{"MENU"} = &makemenu;

if ($mode eq "update") {
	if ($sc == 1) { &update_sched; &show_sched1; }
	if ($sc == 2) { &update_sched; &show_schedmon; }
} elsif ($mode eq "add_col") {
	if ($sc == 1) { &add_sched; &show_sched1; }
} else {
	if ($sc == 1) { &show_sched1; }
	if ($sc == 2) { &show_schedmon; }
}

sub show_schedmon {

	$VAR{'SC_YEAR'} =  "$year";
	$VAR{'SC_MONTH'} = "$month";
#	$VAR{'SC_SELECT_TYPE'} = &select_type;
	$VAR{'SC_GRALIST'} = &select_grauser;
	$VAR{'SC_NAVI'} =  &navimon;
	$VAR{'SC_CAL'} =  &cal;

	$s_yw = &GetYweek ($year, $month, 1);
	$e_yw = &GetYweek ($year, $month, $monthdays[$month - 1]);

	$yw = $s_yw;
	while ($yw <= $e_yw) { push (@yline, $yw); $yw ++; }

	foreach (@yline) {

		$yw = $_;
		my @row = &GetSched ($uid, $year, $yw);

		$r = 1;
   		foreach (@row) {
			chomp;
			@col = split (/\t/);

			my $date = shift (@col);
			my ($m, $d) = split (/\//, $date);
			if ($m eq $month) { $date = $d; }

			push (@col, "");
			$c = 1;
			foreach (@col) {
				($inct1, $inct2, $value, $type1, $type2) = split (/\|/);
				$inct1 =~ s/--:--//;
				$inct2 =~ s/--:--//;

				## insert edit box if mode is "edit" ----
				if ($mode eq "edit" && $yw eq $yweek && $r eq $wday && $c eq $ins) {
					if ($value eq "&nbsp;") { $value = ""; }
					$value =~ s/<BR>/\n/g;
					$value = &edit_box;
					$_ = "$value<BR>\n";

				## show schedule incident if mode is NOT "edit" ----
				} else {
					$inct1 = &MinToTime ($inct1);
					$inct2 = &MinToTime ($inct2);
					if ($inct1 eq "" && $value ne "") { $inct1 = "*"; }
					$inct1 = "<FONT color=\"#000000\">$inct1</FONT>";

					$value =~ s/<BR>/&nbsp;<BR>/g;
					if ($value eq "") {
						if ($RW eq "RW") { $value = "<IMG src=\"$icon_dir/pen.gif\" border=\"0\" align=\"top\">";}
						else { $value = "&nbsp;"; }
					}

					if ($type2 eq "1") { $value = "<FONT class=lFont color=\"#c4c4c4\">$value</FONT>"; }
					elsif ($type1 eq "1") { $value = "<FONT class=lFont color=\"#ff0000\">$value</FONT>"; }
					else { $value = "<FONT class=lFont> $value</FONT>";}


					if ($RW eq "RW") { $value = "<A href=sched.cgi?sc=$sc&uid=$uid&mode=edit&y=$year&m=$month&yw=$yw&wd=$r&i=$c>$value</A>"; }

					$_ = "$inct1 $value<BR>\n";
				}
				$c ++;
			} ## end @col

			while (@col < 3) { push (@col, "<BR>"); }

			unshift (@col,  "<FONT class=lFont color=\"$color\">\n");
			push (@col,  "</FONT>\n");

			if ($year == $THIS_YEAR && $m == $THIS_MONTH && $d == $TODAY) {
				$date = "<U>$date</U>";
			}
			if ($r == 7) { $date = "<FONT class=p8 style=color:#ff0000>$date</FONT><BR>\n"; }
			elsif ($r == 6) { $date = "<FONT class=p8 style=color:#0000ff>$date</FONT><BR>\n"; }
			else { $date = "<FONT class=p8>$date</FONT><BR>\n"; } 
		    	$date = "<A href=sched.cgi?sc=1&uid=$uid&y=$year&yw=$yw>$date</A>";
			unshift (@col, $date);

			$_ = join ("", @col);

			if ($m eq $month) {
				if ($yw % 2) { $_ = "<TD valign=\"top\" class=c13 width=\"14%\" wrap>$_</TD>"; }
				else { $_ = "<TD valign=\"top\" class=c13 width=\"14%\" wrap>$_</TD>"; }
		    	} else { $_ = "<TD valign=\"top\" class=c1>$_</TD>"; }

			$r ++;

		}  ## end @row

		$_ = join ("", @row);
		$_ = "<TR>$_</TR>";

	}
	foreach (@yobi) {
       		$_ = "<FONT class=tFont>$_</FONT><BR>";
		$_ = "<TD width=\"14%\" class=t8 nowrap>$_</TD>";
	}
	unshift (@yobi, "<TR>");
	push (@yobi, "</TR>\n");

	unshift (@yline, @yobi);

	unshift (@yline, "<TABLE width=\"99%\" border=\"0\"  cellpadding=\"0\"cellspacing=\"0\" class=border><TBODY><TR><TD>",
			"<TABLE width=\"100%\" border=\"0\" cellpadding=\"3\" cellspacing=\"1\"><TBODY>\n");
	push (@yline, "</TBODY></TABLE>",
			"</TD></TR></TBODY></TABLE>\n");

#	unshift (@yline, "<FONT class=lFont>$yearǯ $month</FONT><BR><BR>\n");
	$VAR{'SC_SELECT_TYPE'} = &select_type;
	$VAR{'SC_TABLE'} =  "@yline";

	print "Content-type: text/html\n\n";
	&parse_template("$sched_dir/sched$sc.htm", *STDOUT);

}
sub show_sched1 {

#	$VAR{'SC_SELECT_TYPE'} = &select_type;
	$VAR{'SC_GRALIST'} = &select_grauser;
	$VAR{'SC_NAVI'} =  &navi1;
	$VAR{'SC_CAL'} =  &cal;

        @scline = &GetSched ($uid, $year, $yweek);

        $r = 1;
        foreach (@scline) {
                chomp;
                @col = split (/\t/);
		my $date = shift (@col);
		while (@col < 2) { push (@col, ""); }
		my $row_span = @col;
                $c = 1;
                foreach (@col) {
			my ($time, $val, $button);
                        ($inct1, $inct2, $value, $type1, $type2) = split (/\|/);

			## insert edit box if mode is "edit" ----
                        if ($mode eq "edit" && $r eq $wday && $c eq $ins) {
                        	$yw = $yweek;
				$value =~ s/&nbsp;//g;
				$value =~ s/<BR>/\n/g;
                                $value = &edit_box;
				if ($c % 2) { $val = "<TD colspan=\"3\" class=c13>$value</TD>"; }
				else { $val = "<TD colspan=\"3\" class=c1>$value</TD>"; }

			## show schedule incident if mode is NOT "edit" ----
                        } else {
				## show time --
				$inct1 =~ s/--:--//;
				$inct2 =~ s/--:--//;
				$inct1 = &MinToTime ($inct1);
				$inct2 = &MinToTime ($inct2);
				$time = "$inct1 - $inct2";
				$time = "<FONT class=lFont color=\"$color\">$time</FONT>";
				if ($c % 2) { $time = "<TD class=c13 width=\"100\" align=\"center\" nowrap>&nbsp;$time&nbsp;</TD>"; }
				else { $time = "<TD class=c1 width=\"100\" align=\"center\" nowrap>&nbsp;$time&nbsp;</TD>"; }

				## show value --
				if ($value eq "") {
					if ($RW eq "RW") { $val = "<IMG src=\"$icon_dir/pen.gif\" border=\"0\" align=\"top\">"; }
					else { $val = "&nbsp;"; }
				} else {
					$val = $value;
				}
					$val =~ s/<BR>/&nbsp;<BR>/g;

				if ($type2 eq "1") { $val = "<FONT color=\"#c4c4c4\" class=lFont>$val</FONT>"; }
				elsif ($type1 eq "1") { $val = "<FONT color=\"red\" class=lFont>$val</FONT>"; }
				else { $val = "<FONT class=lFont> $val</FONT>";}

				if ($RW eq "RW") { $val = "<A href=sched.cgi?sc=$sc&uid=$uid&y=$year&yw=$yweek&wd=$r&i=$c&mode=edit>$val</A>"; }

				if ($c % 2) { $val = "<TD class=c13 width=\"100%\">$val</TD>"; }
				else { $val = "<TD class=c1 width=\"100%\">$val</TD>"; }

				## show button --
				if ($RW eq "RW" && ($inct1 || $inct2 || $value)) {
					my $button1 = "<A href=sched.cgi?sc=$sc&uid=$uid&y=$year&yw=$yweek&wd=$r&i=$c&mode=add_col><IMG src=$icon_dir/up.gif border=0 align=top></A>";
					my $c2 = $c + 1;
					my $button2 = "<A href=sched.cgi?sc=$sc&uid=$uid&y=$year&yw=$yweek&wd=$r&i=$c2&mode=add_col><IMG src=$icon_dir/down.gif border=0 align=top></A>";
					$button = "$button1 $button2";
				} else {
					$button = "&nbsp;";
				}
				if ($c % 2) { $button = "<TD class=c13 width=\"55\" align=\"center\" nowrap>$button</TD>"; }
				else { $button = "<TD class=c1 width=\"55\" align=\"center\" nowrap>$button</TD>"; }
			}
			if ($c == 1) { $_ = "$time$val$button"; }
			else { $_ = "<TR>$time$val$button</TR>\n"; }

                        $c ++;
                }  ## end of @col

		my ($m, $d) = split (/\//, $date);
		my $eyweek = &GetYweek ($year, 12, 31);
		my $yy;
		if ($yweek > $eyweek && $m == 1) { $yy = $year + 1; }
		elsif ($yweek == 1 && $m == 12) { $yy = $year - 1; }
		else { $yy = $year; }
		$sc_year = $yy;
		$sc_month = $m;

		if ($year == $THIS_YEAR && $m == $THIS_MONTH && $d == $TODAY) { $date = "<FONT class=tFont><U>$date ($yobi[$r - 1])</U></FONT>"; }
		else { $date = "<FONT class=tFont>$date ($yobi[$r - 1])</FONT>"; }
		$date = "<A href=sched.cgi?sc=2&uid=$uid&y=$yy&m=$m>$date</A>";

		$col[0] = "<TR><TD width=\"90\" valign=\"top\" rowspan=\"$row_span\" class=t8 nowrap>$date</TD>$col[0]</TR>\n";

		unshift (@col, "<TR><TD>\n",
				"<TABLE width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\"><TBODY>\n");
		push(@col, "</TBODY></TABLE>\n",
				"</TD></TR>\n");

                $_ = join ("", @col);
                $r ++;
        }

        unshift (@scline, "<TABLE width=\"90%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=border><TBODY><TR><TD>\n",
        		"<TABLE width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\"><TBODY>\n");
	push (@scline, "</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'SC_YEAR'} =  "$sc_year";
	$VAR{'SC_MONTH'} = "$sc_month";
	$VAR{'SC_TABLE'} =  "@scline";
	$VAR{'SC_SELECT_TYPE'} = &select_type;

	print "Content-type: text/html\n\n";
	&parse_template("$sched_dir/sched$sc.htm", *STDOUT);

}
sub edit_box {

	my ($temp, @topt1, @topt2);
	my $t_start = &TimeToMin ($SC_AVAIL_S);
	my $t_end = &TimeToMin ($SC_AVAIL_E);
	if ($t_start >= $t_end) { $t_end += 24 * 60; }

	my $t = $t_start;
	while ($t <= $t_end) {
		 $temp = &MinToTime ($t);
		if ($inct1 ne "" && $t == $inct1) { $temp = "<OPTION value=\"$t\" selected>$temp</OPTION>\n"; }
		else { $temp = "<OPTION value=\"$t\">$temp</OPTION>\n"; }
		 push (@topt1, $temp);
		$t += $SC_AVAIL_INT;
	}
	unshift (@topt1, "<OPTION value=\"\">--:--</OPTION>\n");

	$t = $t_start;
	while ($t <= $t_end) {
		$temp = &MinToTime ($t);
		if ($inct2 ne "" && $t == $inct2) { $temp = "<OPTION value=\"$t\" selected>$temp</OPTION>\n"; }
		else { $temp = "<OPTION value=\"$t\">$temp</OPTION>\n"; }
		push (@topt2, $temp);
		$t += $SC_AVAIL_INT;
	}
	unshift (@topt2, "<OPTION value=\"\">--:--</OPTION>\n");

	if ($type1 eq "1") { $select_type1 = "checked"; }
	if ($type2 eq "1") { $select_type2 = "checked"; }

	return << "EOM";

<CENTER>
<TABLE border=0 class=border cellspacing=0 width=280>
<FORM action=sched.cgi method="POST">
<INPUT type="hidden" name="sc" value="$sc">
<INPUT type="hidden" name="uid" value="$uid">
<INPUT type="hidden" name="mode" value="update">
<INPUT type="hidden" name="y" value="$year">
<INPUT type="hidden" name="m" value="$month">
<INPUT type="hidden" name="yw" value="$yw">
<INPUT type="hidden" name="wd" value="$r">
<INPUT type="hidden" name="i" value="$c">
<TBODY>
<TR>
<TD>
<TABLE border="0" cellspacing="0" width=100%>
<TBODY>
<TR>
<TD align="left" class=c13 width=60% nowrap>&nbsp;<SELECT name="t1">
@topt1
</SELECT> - <SELECT name="t2">
@topt2
</SELECT></TD>
<TD align="right" class=c13 width=20% nowrap>
<FONT class=nFont> </FONT><INPUT type="checkbox" name="type1" value="1" $select_type1>&nbsp;
</TD>
<TD align="right" class=c13 width=20% nowrap>
<FONT class=nFont>ò </FONT><INPUT type="checkbox" name="type2" value="1" $select_type2>&nbsp;
</TD>
</TR>
<TR>
<TD align="center" class=c13 colspan=3>
<TEXTAREA class=aime rows="3" cols="39" name="value">$value</TEXTAREA>
</TD>
</TR>
<TR>
<TD align="center" class=c1 colspan=3><INPUT type="submit" value=""></TD>
</TR>
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</FORM>
</TABLE>
</CENTER>

EOM
}
sub update_sched {
	$value =~ s/(\r\n|\n)/<BR>/g;
#       $value =~ s/ /\&nbsp\;/g;
	$value =~ s/\t/<TAB>/g;

	my $input = "$int1\|$int2\|$value\|$type1\|$type2";

	if ($int1 || $int2 || $value ne "") {
		&UpdateSched ($uid, $year, $yweek, $wday, $ins, $input);
	} elsif ($int1 eq "" && $int2 eq "" && $value eq "" ) {
		&RmIns ($uid, $year, $yweek, $wday, $ins);
	}
}
sub add_sched {

	&AddIns ($uid, $year, $yweek, $wday, $ins, "\|\|\|\|");
}
sub navi1 {
	my $this_yw = &GetYweek ($THIS_YEAR, $THIS_MONTH, $TODAY);
	my $end_yw = &GetYweek ($year, 12, 31);

        my ($y1, $y2, $y3) = ($year, $THIS_YEAR, $year);
        my ($yw1, $yw2, $yw3) = ($yweek - 1, $this_yw, $yweek + 1);

        if ($yw3 >= $end_yw) { $y3 = $year + 1; $yw3 = 1; }
        if ($yw1 <= 1) { $y1 = $year - 1; $end_yw = &GetYweek ($y1, 12, 31); $yw1 = $end_yw; }

	return << "EOM";

<TABLE border="0" width="1%" cellpadding="0" cellspacing="0">
<TBODY>
<TR>
<FORM>
<TD nowrap>
<input type="button" value="轵" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y1&yw=$yw1'"><input type="button" value="" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y2&yw=$yw2'"><input type="button" value="" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y3&yw=$yw3'">
</TD>
</FORM>
</TR>
</TBODY>
</TABLE>
EOM
}

sub navimon {
	my ($y1, $y2, $y3) = ($year, $THIS_YEAR, $year);
	my ($m1, $m2, $m3) = ($month - 1, $THIS_MONTH, $month + 1);

	if ($m3 > 12) { $y3 = $year + 1; $m3 = 1; }
	if ($m1 < 1) { $y1 = $year - 1; $m1 = 12; }

	return << "EOM";

<TABLE border="0" width="1%" cellpadding="0" cellspacing="0">
<TBODY>
<TR>
<FORM>
<TD width="33%" align="right" nowrap>
<INPUT type="button" value="" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y1&m=$m1'"><INPUT type="button" value="" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y2&m=$m2'"><INPUT type="button" value="" onClick="location = 'sched.cgi?sc=$sc&uid=$uid&y=$y3&m=$m3'">
</TD>
</FORM>
</TR>
</TBODY>
</TABLE>

EOM
}
sub select_grauser {
	my @gra;
	my @users = keys (%{$rh_USER});
	@users = sort { $a <=> $b } @users;
	foreach (@users) {
		my $rw = $rh_USER->{"$_"}->{'SC_GRANT'}->{"$myuid"};
		if ($rw) { push (@gra, "$_/$rw"); }
	}
	unshift (@gra, "$myuid/RW");

	foreach (@gra) {
		my ($grantor, $rw) = split (/\//);
		my $uname = $rh_USER->{"$grantor"}->{'NAME'};
		if ($uid == $grantor) {
			$_ = "<OPTION value=\"sched.cgi?sc=$sc&uid=$grantor&y=$year&m=$month&yw=$yweek\" selected>$uname</OPTION>\n";
		} else {
			$_ = "<OPTION value=\"sched.cgi?sc=$sc&uid=$grantor&y=$year&m=$month&yw=$yweek\">$uname</OPTION>\n";
		}
	}

	my $rw_icon;
	if ($RW eq "RW") { $rw_icon = "<IMG src=\"$icon_dir/rw.gif\" border=\"0\" align=\"top\" VSPACE=\"2\" alt=\"Can Write\">"; }
	 else { $rw_icon = "<IMG src=\"$icon_dir/r.gif\" border=\"0\" align=\"top\" VSPACE=\"2\" alt=\"Read Only\">"; }

	return << "EOM";

<TABLE border="0" width="1%" cellpadding="0" cellspacing="0">
<TBODY>
<TR>
<FORM>
<TD width="16.5%" align="left" nowrap>
<SELECT onChange="location=this.options[this.selectedIndex].value">
@gra
</SELECT>
<FONT color=#000000><B></B></FONT>&nbsp;$rw_icon&nbsp;
</TD>
</FORM>
</TR>
</TBODY>
</TABLE>

EOM
}
sub select_type {
        my (@opt, $temp);
        my $c = 1;
        my @label = ("\ɽ\", "\ɽ\");
        foreach (1, 2) {
                if ($_ == $sc) { $temp = "<OPTION value=\"sched.cgi?sc=$_&uid=$uid&y=$sc_year&yw=$yweek&m=$sc_month\" selected>$label[$_ - 1]</OPTION>\n"; }
                else { $temp = "<OPTION value=\"sched.cgi?sc=$_&uid=$uid&y=$sc_year&yw=$yweek&m=$sc_month\">$label[$_ - 1]</OPTION>\n"; }
                push (@opt, $temp);
                $c ++;
        }

        return << "EOM";

<TABLE border="0" width="1%" cellpadding="0" cellspacing="0">
<TBODY>
<TR>
<FORM action="./schedmon.cgi" method="POST">
<TD width="16.5%" align="right" nowrap>
&nbsp;
<SELECT onChange="location=this.options[this.selectedIndex].value">
@opt
</SELECT>
&nbsp;
</TD>
</FORM>
</TR>
</TBODY>
</TABLE>

EOM
}
sub cal {
        return << "EOM";
<A href="schedcal.cgi"><IMG src="$icon_dir/cal.gif" border="0" align="top" VSPACE="2" alt=""></A>
EOM
}

