#!/usr/bin/perl
#
#  GruopCGI2000
#    bkcal.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './cgi-lib.pl';
require './datecalc.pl';
require './makemenu.pl';
require './make_admin_menu.pl';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

## some parameters ----
$icon_dir = '/andicon';
$bk_dir = './template';
$BK_LINK = 1;
$admin_uid = '9999';

## browser parse --
ReadParse(*form);
$bk = $form{'bk'};

## main --
$sys_db = &HashDB::Retrieve ('sys');
$user_db = &HashDB::Retrieve ('user');
$rh_USER = $user_db->GetHash ('USER');
$group_db = &HashDB::Retrieve ('group');
$rh_GROUP = $group_db->GetHash ('GROUP');


$VAR{'YEAR'} = $THIS_YEAR;
$VAR{'MONTH'} = $THIS_MONTH;
$VAR{'DAY'} = $TODAY;
$VAR{'YOBI'} = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$THIS_WDAY];
if ($uid eq $admin_uid) {
	$bk_dir = './admin';
	$VAR{"ADMIN_MENU"} = &make_admin_menu;
}else{
	$VAR{"MENU"} = &makemenu;
}


foreach $set1 ("L", "", "N") {

	if ($set1 eq "L") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR - 1; $sm = 6; }
		else { $year = $THIS_YEAR; $sm = 0; }
	} elsif ($set1 eq "") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR; $sm = 0; }
		else { $year = $THIS_YEAR; $sm = 6; }
	} elsif ($set1 eq "N") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR; $sm = 6; }
		else { $year = $THIS_YEAR + 1; $sm = 0; }
	}

	$VAR{"$set1\YEAR"} = $year;

	for (my $i = 1; $i <= 6; $i ++) {
		$month = $sm + $i;
		@cal = &make_cal;
		$VAR{"$set1\CAL$i"} = "@cal";
	}
}

print "Content-type: text/html\n\n";
&parse_template("$bk_dir/bkcal.htm", *STDOUT);

sub make_cal {
	my (@cal, @wdays);

	my $mlabel = "<FONT class=tFont>$yearǯ $month</FONT>";
	push (@cal, "<TR align=\"center\">\n",
		"<TD colspan=\"7\" class=c10>$mlabel</FONT></TD>\n",
		"</TR>\n");
	push (@cal, "<TR align=\"center\">\n");

	foreach (@yobi) {
		push (@cal, "<TD><FONT class=nFont>$_</FONT></TD>\n");
	}
	push (@cal, "</TR>\n");

	push (@cal, "<TR align=\"center\">\n");

	@wdays = &MonthWday ($year, $month);

	for (my $i = 0; $i < $wdays[0]; $i ++) { push (@cal, "<TD></TD>"); }

	my $wd = $wdays[0];
	my $day = 1;
	foreach (@wdays) {

		my $yweek = &GetYweek ($year, $month, $day);

		if ($year == $THIS_YEAR && $month == $THIS_MONTH && $day == $TODAY) {
			$_ = "<FONT class=tFont><B>$day</B></FONT>";
			if ($BK_LINK) {
				$_ = "<A href=bk.cgi?bk=$bk&y=$year&m=$month&d=$day>$_</A>";
			}
			push (@cal, "<TD class=t7>$_</TD>\n");
		} else {
			if ($wd == 0) { $_ = "<FONT style=color:#ff0000 class=nFont>$day</FONT>"; }
			elsif ($wd == 6) { $_ = "<FONT style=color:#0000ff class=nFont>$day</FONT>"; }
			else { $_ = "<FONT class=nFont>$day</FONT>"; }
			if ($BK_LINK) {
				$_ = "<A href=bk.cgi?bk=$bk&y=$year&m=$month&d=$day>$_</A>";
			}
			push (@cal, "<TD>$_</TD>\n");
		}

		if ($wd == 6) {
			push (@cal, "</TR>\n", "<TR align=\"center\">\n");
			$wd = -1;
		}

		$wd ++; $day ++;
	}
	push (@cal, "</TR>\n");
			
	unshift (@cal, "<TABLE border=\"0\" cellpadding=\"5\" cellspacing=0><TBODY>\n");
	push (@cal, "</TBODY></TABLE>\n");

	return @cal;
}

