#!/usr/bin/perl
#
#  GruopCGI2000
#    schedcal.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './datecalc.pl';
require './template.pl';
require './makemenu.pl';

$cal_dir = './template';
$SCHED_LINK = 1;
$icon_dir = '/andicon';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

## main --
$user_db = &HashDB::Retrieve ('user');
$sys_db = &HashDB::Retrieve ('sys');
$rh_USER = $user_db->GetHash ('USER');
$group_db = &HashDB::Retrieve ('group');
$rh_GROUP = $group_db->GetHash ('GROUP');
$rh_user = $rh_USER->{"$uid"};

$VAR{'YEAR'} = $THIS_YEAR;
$VAR{'MONTH'} = $THIS_MONTH;
$VAR{'DAY'} = $TODAY;
$VAR{'YOBI'} = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$THIS_WDAY];
$VAR{"MENU"} = &makemenu;

foreach $set1 ("L", "", "N") {

	if ($set1 eq "L") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR - 1; $sm = 6; }
		else { $year = $THIS_YEAR; $sm = 0; }
	} elsif ($set1 eq "") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR; $sm = 0; }
		else { $year = $THIS_YEAR; $sm = 6; }
	} elsif ($set1 eq "N") {
		if ($THIS_MONTH < 7) { $year = $THIS_YEAR; $sm = 6; }
		else { $year = $THIS_YEAR + 1; $sm = 0; }
	}

	$VAR{"$set1\YEAR"} = $year;

	for (my $i = 1; $i <= 6; $i ++) {
		$month = $sm + $i;
		@cal = &make_cal;
		$VAR{"$set1\CAL$i"} = "@cal";
	}
}

print "Content-type: text/html\n";
print "Pragma: no-cache\n";
print "Cache-Control: no-cache\n\n";
&parse_template("$cal_dir/schedcal.htm", *STDOUT);

sub make_cal {
	my (@cal, @wdays);
	$s_yw = &GetYweek ($year, $month, 1);
	my $slink = "<FONT class=tFont>$yearǯ $month</FONT>";
	if ($SCHED_LINK) {
		$slink = "<A href=sched.cgi?sc=2&y=$year&m=$month&yw=$s_yw>$slink</A>";
	}

	push (@cal, "<TR align=\"center\">\n",
		"<TD colspan=\"7\" class=c8>$slink</FONT></TD>\n",
		"</TR>\n");
	push (@cal, "<TR align=\"center\">\n");
	foreach (@yobi) {
		push (@cal, "<TD><FONT class=nFont>$_</FONT></TD>\n");
	}
	push (@cal, "</TR>\n");

	push (@cal, "<TR align=\"center\">\n");

	@wdays = &MonthWday ($year, $month);

	for (my $i = 0; $i < $wdays[6]; $i ++) { push (@cal, "<TD></TD>"); }

	my $wd = $wdays[0];
	my $day = 1;
	foreach (@wdays) {

		my $yweek = &GetYweek ($year, $month, $day);

		if ($year == $THIS_YEAR && $month == $THIS_MONTH && $day == $TODAY) {
			$_ = "<FONT class=tFont><B>$day</B></FONT>";
			if ($SCHED_LINK) {
				$_ = "<A href=sched.cgi?sc=1&y=$year&yw=$yweek>$_</A>";
			}
			push (@cal, "<TD class=t7>$_</TD>\n");
		} else {
			if ($wd == 0) { $_ = "<FONT style=color:#ff0000 class=nFont>$day</FONT>"; }
			elsif ($wd == 6) { $_ = "<FONT style=color:#0000ff class=nFont>$day</FONT>"; }
			else { $_ = "<FONT class=nFont>$day</FONT>"; }
			if ($SCHED_LINK) {
				$_ = "<A href=sched.cgi?sc=1&y=$year&yw=$yweek>$_</A>";
			}
			push (@cal, "<TD>$_</TD>\n");
		}

		if ($wd == 0) {
			push (@cal, "</TR>\n", "<TR align=\"center\">\n");
		}
		if ($wd == 6) {
			$wd = -1;
		}

		$wd ++; $day ++;
	}
	push (@cal, "</TR>\n");
			
	unshift (@cal, "<TABLE border=\"0\" cellpadding=\"5\" cellspacing=0><TBODY>\n");
	push (@cal, "</TBODY></TABLE>\n");

	return @cal;
}

