#!/usr/bin/perl
#
#  GruopCGI2000
#    uconfig.cgi ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './cgi-lib.pl';
require './makemenu.pl';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

$icon_dir = '/andicon';
$uconfig_dir = './template';

## browser parse --
ReadParse(*form);
$mode = $form{'mode'};
$pass0 = $form{'pass0'};
$pass1 = $form{'pass1'};
$pass2 = $form{'pass2'};
$grauid = $form{'grauid'};
$permit = $form{'permit'};
$sc_s = $form{'sc_s'};
$sc_e = $form{'sc_e'};
$sc_int = $form{'sc_int'};

## main -----
$user_db = &HashDB::Retrieve ('user');
$rh_USER = $user_db->GetHash ('USER');
$rh_user = $rh_USER->{"$uid"};

$group_db = &HashDB::Retrieve ('group');
$rh_GROUP = $group_db->GetHash ('GROUP');

$sys_db = &HashDB::Retrieve ('sys');
$rh_SC = $sys_db->GetHash ('SYS_SC_CONFIG');

$default_gid = $rh_user->{'DEFAULT_GID'};
@hide_item;
if ($default_gid) {
	@hide_item = split(/\W/, $rh_GROUP->{$default_gid}->{'HIDE_ITEM'});
}else{
	$rh_HIDE = $sys_db->GetHash ('HIDE_ITEM');
	@hide_item = split(/\W/, $rh_HIDE->{'HIDE_ITEM'});
}

($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $WDAY) = localtime(time);
$VAR{'MONTH'} = $THIS_MONTH + 1;
$VAR{'DAY'} = $TODAY;
$VAR{'YOBI'} = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$WDAY];
$VAR{"MENU"} = &makemenu;

if ($mode eq "chpass") {
	if (!&CheckUserPasswd ($uid, $pass0)) {
		&invalid_old_pass;
	} else {
		if ($pass1 eq $pass2) {
			&ChangeUserPasswd ($uid, $pass1);
			&success_new_pass;
		} else {
			&invalid_new_pass;
		}
	}

} elsif ($mode eq "del_grantee") {
	my @del_grantees = split(/\W/, $grauid);
	foreach (@del_grantees) {
		delete ($rh_USER->{"$uid"}->{'SC_GRANT'}->{"$_"});
	}
	$user_db->SetHash ('USER', $rh_USER);
	$user_db->Store ();

} elsif ($mode eq "add_grantee") {
	if ($grauid && $permit) {
		$rh_USER->{"$uid"}->{'SC_GRANT'}->{"$grauid"} = $permit;
		$user_db->SetHash ('USER', $rh_USER);
		$user_db->Store ();
	}
} elsif ($mode eq "set_scconfig") {
	if ($sc_s =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_S'} = "$sc_s"; }
	if ($sc_e =~ /^[0-2]?[0-9]\:[0-5][0-9]$/) { $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_E'} = "$sc_e"; }
	if ($sc_int =~ /^[0-9]+$/) { $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_INT'} = "$sc_int"; }
	$user_db->SetHash ('USER', $rh_USER);
	$user_db->Store ();

}

&show_uconfig ();

sub show_uconfig {

	if (-e "sched.cgi") {
		my $flag;
		foreach (@hide_item) {
			$flag = 1 if $_ eq 2;
		}
		if (! $flag) {
			$VAR{'SCHED'} = &make_sched;
		}
	}
	
	print "Content-type: text/html\n\n";
	&parse_template("$uconfig_dir/uconfig.htm", *STDOUT);
}

##
##  Error Screens ----
##
sub invalid_old_pass {

	print "Content-type:text/html\n\n";
	print <<"EOM";
<LINK REL=STYLESHEET HREF="/andicon/gc2000.css" TYPE="text/css">
<BR>
<BR>
<BR>
<BR>
<CENTER>
<TABLE class=border border="0" width="400" cellspacing=0>
<FORM>
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellpadding="5" cellspacing=0 colspan=2 nowrap>
<TBODY>
<TR>
<TD class=t10 colspan=2 nowrap><FONT class=tFont>ѥɤޤ</FONT></TD>
</TR>
<TR>
<TD class=c12 align="center" colspan=2 nowrap>
<FONT class=nFont>
Ϥ줿ѥɤϡԤΥѥɤ˰פޤ<BR>
ѥɤѹϡ⤦١ѹԤäƤ<BR>
ɤƤѹǤʤˤϡԤؤϢ
</FONT>
</TD>
<TR>
<TD align="center" class=c1 colspan=2><INPUT TYPE="button" VALUE="   " onClick="location = 'uconfig.cgi'"></TD>
</TR>
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</FORM>
</TABLE>
</CENTER>
EOM

exit;
}
sub invalid_new_pass {

	print "Content-type:text/html\n\n";
	print <<"EOM";
<LINK REL=STYLESHEET HREF="/andicon/gc2000.css" TYPE="text/css">
<BR>
<BR>
<BR>
<BR>
<CENTER>
<TABLE class=border border="0" width="400" cellspacing=0>
<FORM>
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellpadding="5" cellspacing=0 colspan=2 nowrap>
<TBODY>
<TR>
<TD class=t10 colspan=2 nowrap><FONT class=tFont>ѥɤޤ</FONT></TD>
</TR>
<TR>
<TD class=c12 align="center" colspan=2 nowrap>
<FONT class=nFont>
ѥɤȡǧϤ줿ѥɤפƤޤ<BR>
ѥɤѹϡ⤦١ѹԤäƤ<BR>
ɤƤѹǤʤˤϡԤؤϢ
</FONT>
</TD>
<TR>
<TD align="center" class=c1 colspan=2><INPUT TYPE="button" VALUE="   " onClick="location = 'uconfig.cgi'"></TD>
</TR>
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</FORM>
</TABLE>
</CENTER>
EOM

exit;
}
sub success_new_pass {

	print "Content-type:text/html\n\n";

	print <<"EOM";
<LINK REL=STYLESHEET HREF="/andicon/gc2000.css" TYPE="text/css">
<BR>
<BR>
<BR>
<BR>
<CENTER>
<TABLE class=border border="0" width="400" cellspacing=0>
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellpadding="5" cellspacing=0>
<TBODY>
<TR>
<TD class=t4 nowrap><FONT class=tFont>ѥɤѹޤ</FONT></TD>
</TR>
<TR>
<TD class=c12 align="center">
<FONT class=nFont>
󤫤ΥˤϡѥɤѤƤ<BR>
<BR>
ѥɤϡ $pass1 פǤ<BR>
<BR>
˺ʤͤˡ줰դƤ
</FONT>
</TD>
<TR>
<TD align="center" class=c1 colspan=2><INPUT TYPE="button" VALUE="桼" onClick="location = 'uconfig.cgi'"></TD>
</TR>
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</TABLE>
</CENTER>

EOM

exit;
}
sub make_sched {

	## making grantees table ----
	my @grantees = keys (%{$rh_USER->{"$uid"}->{'SC_GRANT'}});
	@grantees = sort { $a <=> $b } @grantees;

	my $r = 1;
	foreach (@grantees) {
		my $granteeid = $_;	
		my $rw = $rh_USER->{"$uid"}->{'SC_GRANT'}->{"$granteeid"};	

		if ($rw eq "RW") { $rw = "<IMG src=\"$icon_dir/rw.gif\" border=\"0\" align=\"bottom\" alt=\"Can Write\">";}
		else { $rw = "<IMG src=\"$icon_dir/r.gif\" border=\"0\" align=\"bottom\" alt=\"Read Only\">";}

		my $gid = $rh_USER->{"$granteeid"}->{'GROUP_ID'};
		my @col = (
#				$granteeid,
				$rh_USER->{"$granteeid"}->{'NAME'},
				$rh_GROUP->{"$gid"}->{'NAME'},
				$rh_USER->{"$granteeid"}->{'EMAIL'},
				$rw);

		push (@col, "<INPUT type=\"checkbox\" name=\"grauid\" value=\"$granteeid\">");

		foreach (@col) {
			if ($_ eq "") { $_ = " - "; }
			if (/\w+@\w+/) {
				$_ = "<TD nowrap><FONT class=lFont><A HREF=MAILTO:$_>$_</A></FONT></TD>";
			} else {
				$_ = "<TD nowrap><FONT class=nFont>$_</FONT></TD>";
			}
		}

		if ($r % 2) { $TR = "<TR class=c13 align=\"center\">\n"; }
		else { $TR = "<TR class=c1 align=\"center\">\n"; }

		unshift (@col, $TR);
		push (@col, "</TR>\n");

                $_ = join ("", @col);
                $r ++;
        }
        ## table header --
        unshift (@grantees, "<TR align=\"center\" class=c1>",
#                         "<TD nowrap><FONT class=nFont>桼ID</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>桼̾</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>롼̾</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>᡼륢ɥ쥹</FONT></TD>",
                         "<TD nowrap><FONT class=nFont>ϰ</FONT></TD>",
                         "<TD nowrap><INPUT type=\"submit\" value=\"\"></TD>",
                         "</TR>\n");

#        unshift (@grantees, "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY>\n");
#        push (@grantees, "</TBODY></TABLE>\n");

#	unshift (@grantees, "<FORM action=\"uconfig.cgi\" method=\"POST\"\n>",
#			"<INPUT type=\"hidden\" name=\"mode\" value=\"del_grantee\">\n");
#        unshift (@grantees, "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY>\n");

#	push (@grantees, "</FORM>\n");
#        push (@grantees, "</TBODY></TABLE>\n");

	## making all users list ----
	my @users = keys (%{$rh_USER});
	@users = sort { $a <=> $b } @users;
        foreach (@users) {
		if ($_ eq "9999") { $_ = ""; next; }
		if ($_ == $uid ) { $_ = ""; next; }
                my $uname = $rh_USER->{"$_"}->{'NAME'};
                $_ = "<OPTION value=\"$_\">$uname</OPTION>\n";
        }
	unshift (@users, "<OPTION value=\"\" selected>-- 桼 --</OPTION>\n");

	## sched config ----
	my $sc_avail_s = $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_S'};
	my $sc_avail_e = $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_E'};
	my $sc_avail_int = $rh_USER->{"$uid"}->{'SC_CONFIG'}->{'AVAIL_INT'};
	if (!$sc_avail_s) { $sc_avail_s = $rh_SC->{'AVAIL_S'}; }
	if (!$sc_avail_e) { $sc_avail_e = $rh_SC->{'AVAIL_E'}; }
	if (!$sc_avail_int) { $sc_avail_int = $rh_SC->{'AVAIL_INT'}; }

	return <<"EOM";

<TABLE border="0" width="450" class=border cellpadding=1 cellspacing=0>
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellpadding=5 cellspacing=0>
<FORM action="uconfig.cgi" method="GET">
<TBODY>
<TR>
<TD align="center" colspan=2 class=t8 nowrap><FONT class=tFont>塼αĤ桼ɲ</FONT></TD>
</TR>
<TD align="right" class=c12 width="32%" nowrap><FONT class=nFont>桼̾ </FONT></TD>
<TD class=c12 align="left">
<SELECT name="grauid">
@users
</SELECT>
</TD>
</TR>
<TR>
<TD class=c12 align="right" nowrap><FONT class=nFont>ϰ </FONT></TD>
<TD class=c12 align="left" nowrap><INPUT type="radio" name="permit" value="R" checked><FONT class=nFont></FONT>&nbsp;<IMG src="/andicon/r.gif" border="0" align="top" VSPACE="3"
>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT type="radio" name="permit" value="RW"><FONT class=nFont>ߤޤ</FONT>&nbsp;<IMG src="/andicon/rw.gif" border="0" align="top" VSPACE="3">
</TD>
</TR>
<TR>
<TD align="center" class=c1 colspan="2"><INPUT type="submit" value="   "></TD>
</TR>
</TBODY>
<INPUT type="hidden" name="mode" value="add_grantee"></FORM>
</TABLE>
</TD>
</TR>
</TBODY>
</TABLE>

<BR>

<TABLE border="0" width="90%" cellpadding=5 cellspacing=0>
<TBODY>
<TR>
<TD align="left">
<FONT class=p8> </FONT><FONT class=nFont>塼αĤƤ桼</FONT>
</TD>
</TR>
</TBODY>
</TABLE>

<TABLE border="0" width="90%" class=border cellpadding=0 cellspacing=0>
<FORM action="uconfig.cgi" method="GET">
<INPUT type="hidden" name="mode" value="del_grantee">
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellpadding=2 cellspacing=1>
<TBODY>
@grantees
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</FORM>
</TABLE>

<BR>
<BR>

<CENTER>
<TABLE border="0" width="350" class=border cellspacing=0>
<FORM action="uconfig.cgi" method="GET">
<INPUT type="hidden" name="mode" value="set_scconfig">
<TBODY>
<TR>
<TD>
<TABLE border="0" width="100%" cellspacing=0 cellpadding=5>
<TBODY>
<TR>
<TD align="center" colspan=2 class=t8 nowrap>
<FONT class=tFont>塼ܥå</FONT>
</TD>
</TR>
<TR>
<TD align="right" class=c12 width="45%" nowrap><FONT class=nFont>ϰ </FONT></TD>
<TD class=c12>
<script language="JavaScript">
<!-----
document.write("<input type='text' name='sc_s' value='$sc_avail_s' size='" + SizeSet(4.5) + "' class=dime>");
// ----->
</script>
&nbsp;<FONT class=nFont>-</FONT>&nbsp;
<script language="JavaScript">
<!-----
document.write("<input type='text' name='sc_e' value='$sc_avail_e' size='" + SizeSet(4.5) + "' class=dime>");
// ----->
</script>
</TD>
</TR>
<TR>
<TD align="right" class=c12 nowrap><FONT class=nFont>ֳִ </FONT></TD>
<TD class=c12>
<script language="JavaScript">
<!-----
document.write("<input type='text' name='sc_int' value='$sc_avail_int' size='" + SizeSet(3) + "' class=dime>");
// ----->
</script>
<FONT class=nFont>ʬ</FONT>
</TD>
</TR>
<TR>
<TD align="center" class=c1 colspan="2"><INPUT type="submit" value="   ">
</TD>
</TR>
</TBODY>
</TABLE>
</TD>
</TR>
</TBODY>
</FORM>
</TABLE>
</CENTER>

<BR>
<BR>
EOM
}