#!/usr/bin/perl
#
#  GruopCGI2000
#    wb.pl ver.3.10.00.0705
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All rights reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
$my_name = 'wb.pl';

$def_col_num = 8;
$def_row_num = 4;

sub CreateWb {

	my ($wbname) = @_;

	my (@col, @line, $i);
	for ($i=0; $i < $def_col_num; $i ++) {
		$col[$i] = "&nbsp;";
	}
	$i = join ("\t", @col);
	$line[0] = "$i\n";

	for ($i=1; $i < $def_row_num; $i ++) {
		$line[$i] = "&nbsp;\n";
	}

	open (WB, ">$wbname")
                         || &Error::error ("$my_name\:\:CreateWb","Can't open $wbname");
	print WB @line;
	close (WB);
}
sub GetWb {
	my ($wbname) = @_;
	my $file = "$wbname";
	my (@oline, $c_num);
	
	if (!(-e "$file")) { &CreateWb ($wbname); }

	open (WB, "$file")
	         || &Error::error ("$my_name\:\:GetWb","Can't open $file");
	my @line = <WB>;
	close (WB);

	my $r = 1;
	my $flag = 1;
	foreach (@line) {
                if (/^#/) { next; }
		chomp;
		@col = split (/\t/);
		if ($flag) { $c_num = @col; $flag = 0; }
                @col = splice (@col, 0, $c_num);
		if (@col < $c_num) {
	                for ($i = @col; $i < $c_num; $i++) {
				$col[$i] = "&nbsp;";
               		}
		}
		$_ = join ("\t", @col);
		push (@oline, "$_\n");
		$r ++;
	}
	return @oline;
}
sub UpdateWb {
	my ($wbname, $r_num, $c_num, $value) = @_;
	my $file = "$wbname";
	
	if (!(-e "$file")) { return 0; } ## No such file!!

	open (WB, "$file")
	         || &Error::error ("$my_name\:\:UpdateWb","Can't open $file");
	my @line = <WB>;
	close (WB);
	if (@line < $r_num) {
                for ($i = @line; $i < $r_num; $i++) {
			$line[$i] = "&nbsp;";
                }
	}

	my $r = 1;
	foreach (@line) {
                if (/^#/) { next; }
		if ($r_num eq $r) {
			chomp;
			@col = split (/\t/);
			if (@col < $c_num) {
		                for ($i = @col; $i < $c_num; $i++) {
					$col[$i] = "&nbsp;";
                		}
			}
			$col[$c_num - 1] = $value;
			$_ = join ("\t", @col);
			$_ = "$_\n";
		}
		$r ++;
	}
	open (WB, ">$file") || &Error::error ("$my_name\:\:UpdateWb","Can't open $file");
	flock (WB, 2);
	seek (WB, 0, 2);
	print WB @line;
	flock (WB, 8);
	close (WB);
}

1; #return true

